//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"
#include <Math.hpp>
#include <fstream>


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner):TForm(Owner)
{
   data_generated=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button_Estim_aClick(TObject *Sender)
{   if (data_generated==0)      Button2Click(Sender) ;
    Form1->model=1;
    p1min=-10;  p1max=10;
    p2min=-10;  p2max=10;
    R1=repere(Image1,p1min,p1max,p2min,p2max);
    R1.Clean();
    if (RadioGroup1->ItemIndex==0)
           GO_SIVIA();
           else GO_MC();

    Image1->Picture->SaveToFile("Rsivia.bmp");
    Image2->Picture->SaveToFile("R_data_a.bmp");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button_Estim_bClick(TObject *Sender)
{   if (data_generated==0)     Button2Click(Sender) ;
    Form1->model=2;
    p1min=-10;  p1max=10;
    p2min=-10;  p2max=10;
    R1=repere(Image1,p1min,p1max,p2min,p2max);
    R1.Clean();
    if (RadioGroup1->ItemIndex==0)
           GO_SIVIA();
           else GO_MC();
    Image1->Picture->SaveToFile("Rsivia.bmp");
    Image2->Picture->SaveToFile("R_data_b.bmp");
}

//---------------------------------------------------------------------------
double pfp(int m, double pie, int q)
{   if ((pie==0)||(pie==1)) return pie;

    double num=m*(1-pie)-q;
    double den=sqrt(2*m*pie*(1-pie));
    double erf1=Erf(num/den);
    double pfp1=1-0.5*(1+erf1);
    return(pfp1);
}
//---------------------------------------------------------------------------

void MAJ()
{
        Form1->m=500;
        Form1->q=(int)((0.01*Form1->TrackBar_q->Position)*Form1->m);
        Form1->prob_a=(0.01*Form1->TrackBar_prob_a->Position);
        Form1->prob_b=(0.01*Form1->TrackBar_prob_b->Position);

        Form1->emax=0.1;
        Form1->dt=0.02;
        Form1->pfp_a=pfp(Form1->m,Form1->prob_a,Form1->q);
        Form1->pfp_b=pfp(Form1->m,Form1->prob_b,Form1->q);



        Form1->Memo1->Text="m = "+String(Form1->m)+" \r\n ";
        Form1->Memo1->Text=Form1->Memo1->Text+"q = "+String(Form1->q)+" \r\n ";
        Form1->Memo1->Text=Form1->Memo1->Text+"Prior feasible probability for model a = "+String(Form1->pfp_a)+" \r\n ";
        Form1->Memo1->Text=Form1->Memo1->Text+"Prior feasible probability for model b = "+String(Form1->pfp_b)+" \r\n ";
        Form1->Memo1->Text=Form1->Memo1->Text+"prob_a = "+String(Form1->prob_a)+" \r\n ";
        Form1->Memo1->Text=Form1->Memo1->Text+"prob_b = "+String(Form1->prob_b)+" \r\n ";
    //Form1->Memo1->Text=Form1->Memo1->Text+ "a = ["+String(a.GetInf())+" , "+String(a.GetSup())+" \r\n ";
    //Form1->Memo1->Text=Form1->Memo1->Text+"Number of boxes = " + A.size()+" \r\n "  ;
}




void __fastcall TForm1::Button2Click(TObject *Sender)
{   MAJ();
    tmin=0;    tmax=10;
    ymin=-10;  ymax=10;
    R2=repere(Image2,tmin,tmax,ymin,ymax);
    R2.Clean();

    T.clear();       Y.clear();;
    double pa1=2;
    double pa2=2;
    double pb1=4;
    double pb2=-0.4;
    for (int k=0;k<m;k++)
        {   double t=(k+1)*dt;
            interval Tk=t+interval(-0.0001,0.0001);
            double s=1.0*rand()/RAND_MAX;
            double b=emax*((1.0*rand()/RAND_MAX)-0.5);
            double yk;
            if (s<prob_a)
               yk=pa1*sin(pa2*t)+b;
               else if (s<prob_a+prob_b)
               yk=pb1*exp(pb2*t)+b;
               else yk=RandG(2.0, 3.0);
            interval Yk=yk+interval(-emax,emax);
            Y.push_back(Yk);
            T.push_back(Tk);
         }

    fstream Fout;
    Fout.open("data.txt",fstream::out);
    Fout <<"Inf(T)   Sup(T[k])   Inf(Y[k])  Sup(Y[k])"<<"\n";

    for (int k=0;k<m;k++)
    { box Q(2);
      Q[1]=T[k];
      Q[2]=Y[k];
      R2.DrawBox(Q,clLtGray,clLtGray,bsSolid);
      Fout <<Inf(T[k])<<"  "<<Sup(T[k])<<"  "<<Inf(Y[k])<<"  "<<Sup(Y[k])<<"\n";
    }
    R2.image->Refresh();
    Image2->Picture->SaveToFile("R_data_0.bmp");


  Fout.close();
}




//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar_qChange(TObject *Sender)
{
        MAJ();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar_prob_aChange(TObject *Sender)
{          int pa,pb;
           pa=Form1->TrackBar_prob_a->Position;
           pb=Form1->TrackBar_prob_b->Position;
           if (pa+pb>100)
              Form1->TrackBar_prob_b->Position=100-pa;
           MAJ();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar_prob_bChange(TObject *Sender)
{
           int pa,pb;
           pa=Form1->TrackBar_prob_a->Position;
           pb=Form1->TrackBar_prob_b->Position;
           if (pa+pb>100)
              Form1->TrackBar_prob_a->Position=100-pb;
           MAJ();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

